//Grabación de los datos de la respuesta del Péndulo Invertido
clear;
close(winsid());
clc;
//*******************************************
// Simulación del modelo no lineal desde XCOS
//*******************************************
// Carga el diagrama a simular

loadXcosLibs(); loadScicos();

importXcosDiagram("Pendulo_Invertido_realim.zcos")

typeof(scs_m) //Estructura del diagrama

//Simulación con los parámetros del diagrama
scicos_simulate(scs_m);
close(winsid());

// Gráfica de los datos adquiridos
Posicion_1=posicion.values;
Tiempo=posicion.time;
Angulo_1=angulo.values;
subplot(211)
plot2d(Tiempo,Posicion_1,color("red"));
xgrid(color("gray"))
subplot(212)
plot2d(Tiempo,Angulo_1,color("red"));
xgrid(color("gray"))


// animacion_pendulo.sce

// Create motion data -- (1)
//t=posicion.time;
t=angulo.time;
//t = 0:0.001:1;    // Time data
//x=posicion.values;
q=angulo.values+%pi/2;
//x = sin(2*%pi*t); // Position data
R=5;
z=posicion.values;
for j=1:length(t)
x(j)=R*cos(q(j))+z(j);
y(j)=R*sin(q(j));
end

z=posicion.values;
// Draw initial figure -- (2)
h_fig = figure("position",[0,0,1200,600]);
h_fig.background = 8;
drawlater();
h_point = plot(x(1), y(1), 'Marker', 'o', 'MarkerSize', 20,..
    'MarkerEdgeColor', 'blue', 'MarkerFaceColor', 'blue');
h_squar = plot(z(1), 0, 'Marker', 'square', 'MarkerSize', 60,..
    'MarkerEdgeColor', 'blue', 'MarkerFaceColor', 'red');
h_bar = plot([z(1);x(1)],[0;y(1)]);
h_bar.thickness = 3;
//h_prueba=plot3d(x(1),y(1),z(1))
h_axes = gca();
h_axes.data_bounds = [-12, -6; 12, 6];

// Animation Loop -- (3)
realtimeinit(0.01); // set time unit duration, in seconds
realtime(0);       // set current time to 0
for i = 1:length(x)
    drawlater();
    h_point.data = [x(i), y(i)];
    h_squar.data = [z(i), 0];
    h_bar.data = [z(i),0;x(i),y(i)];
    xgrid()
    realtime(i); // wait until i time units (0.1*i seconds)
    drawnow();
end



